﻿Imports System.Globalization  ' 和暦を扱うために必要

Partial Class _Default
  Inherits System.Web.UI.Page
  ' 元号のチェック
  Protected Sub BirthDayGengoCustomValidator_ServerValidate(ByVal source As Object, ByVal args As System.Web.UI.WebControls.ServerValidateEventArgs) Handles BirthDayGengoCustomValidator.ServerValidate
    ' 年月日いずれか入力されているか判定
    If Not String.IsNullOrEmpty(BirthDayYearTextBox.Text) _
     OrElse Not String.IsNullOrEmpty(BirthDayMonthTextBox.Text) _
     OrElse Not String.IsNullOrEmpty(BirthDayDayTextBox.Text) _
    Then
      ' 入力されている
      ' 元号が選択されていなければエラーとする
      If String.IsNullOrEmpty(args.Value) Then
        args.IsValid = False
      Else
        args.IsValid = True
      End If
    Else
      ' 入力されていない
      args.IsValid = True
    End If
  End Sub

  ' 誕生日の日付チェック
  Protected Sub BirthDayCustomValidator_ServerValidate(ByVal source As Object, ByVal args As System.Web.UI.WebControls.ServerValidateEventArgs) Handles BirthDayCustomValidator.ServerValidate
    ' 誕生日項目のいずれかが入力されているときのみチェックを行う
    If BirthDayGengoDropDownList.SelectedIndex > 0 _
      OrElse Not String.IsNullOrEmpty(BirthDayYearTextBox.Text) _
      OrElse Not String.IsNullOrEmpty(BirthDayMonthTextBox.Text) _
      OrElse Not String.IsNullOrEmpty(BirthDayDayTextBox.Text) _
    Then
      ' 入力値を取得する
      Dim gengo As String = BirthDayGengoDropDownList.SelectedValue
      Dim year As String = BirthDayYearTextBox.Text.Trim()
      Dim month As String = BirthDayMonthTextBox.Text.Trim()
      Dim day As String = BirthDayDayTextBox.Text.Trim()

      ' 入力値が和暦として正しくなければエラー
      Dim birthDayString As String = String.Format( _
        "{0}{1}年{2}月{3}日", gengo, year, month, day)
      Dim culture As New CultureInfo("ja-JP", True)
      culture.DateTimeFormat.Calendar = New JapaneseCalendar()
      Dim birthDay As Date
      If DateTime.TryParseExact( _
        birthDayString _
        , "ggy年M月d日" _
        , culture _
        , DateTimeStyles.None _
        , birthDay) _
      Then
        args.IsValid = True
      Else
        args.IsValid = False
      End If
    Else
      args.IsValid = True
    End If
  End Sub

  ' サイトをどこで知ったかチェック
  Protected Sub CheckCustomValidator_ServerValidate(ByVal source As Object, ByVal args As System.Web.UI.WebControls.ServerValidateEventArgs) Handles CheckCustomValidator.ServerValidate
    ' 最低1つは選択されていないとエラー
    If TVCheckBox.Checked _
      OrElse NewsPaperCheckBox.Checked _
      OrElse MagazineCheckBox.Checked _
      OrElse FriendCheckBox.Checked _
      OrElse WebSearchCheckBox.Checked _
      OrElse OtherCheckBox.Checked _
    Then
      args.IsValid = True
    Else
      args.IsValid = False
    End If
  End Sub

  ' サイトの評価チェック
  Protected Sub RadioCustomValidator_ServerValidate(ByVal source As Object, ByVal args As System.Web.UI.WebControls.ServerValidateEventArgs) Handles RadioCustomValidator.ServerValidate
    ' どれか一つ選択されていないとエラー
    If VeryGoodRadioButton.Checked _
      OrElse GoodRadioButton.Checked _
      OrElse NormalRadioButton.Checked _
      OrElse BadRadioButton.Checked _
      OrElse VeryBadRadioButton.Checked _
    Then
      args.IsValid = True
    Else
      args.IsValid = False
    End If
  End Sub

  ' 送信ボタンクリック
  Protected Sub PostButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles PostButton.Click
    ' 結果のクリア
    ResultLabel.Text = ""

    ' チェック結果判定
    If Page.IsValid Then
      ' チェック結果エラーなし
      ' 入力値を表示
      ' 氏名
      ResultLabel.Text += String.Format( _
        "氏名：{0} {1}" _
        , FamilyNameTextBox.Text _
        , FirstNameTextBox.Text)
      ResultLabel.Text += "<br />"
      ' フリガナ
      ResultLabel.Text += String.Format( _
        "フリガナ：{0} {1}" _
        , FamilyNameKanaTextBox.Text _
        , FirstNameKanaTextBox.Text)
      ResultLabel.Text += "<br />"
      ' メールアドレス
      ResultLabel.Text += String.Format( _
        "メールアドレス：{0}" _
          , MailAddressTextBox.Text)
      ResultLabel.Text += "<br />"
      ' 誕生日
      ResultLabel.Text += String.Format( _
        "誕生日：{0}{1}年{2}月{3}日" _
        , New String() { _
          BirthDayGengoDropDownList.SelectedValue _
          , BirthDayYearTextBox.Text _
          , BirthDayMonthTextBox.Text _
          , BirthDayDayTextBox.Text _
          })
      ResultLabel.Text += "<br />"
      ' 職業
      ResultLabel.Text += String.Format( _
        "職業：{0}" _
        , JobListBox.SelectedValue)
      ResultLabel.Text += "<br />"
      ' サイトをどこで知ったか
      Dim checkTexts As String = ""
      If TVCheckBox.Checked Then
        checkTexts += TVCheckBox.Text
      End If
      If NewsPaperCheckBox.Checked Then
        If checkTexts <> "" Then
          checkTexts += ", "
        End If
        checkTexts += NewsPaperCheckBox.Text
      End If
      If MagazineCheckBox.Checked Then
        If checkTexts <> "" Then
          checkTexts += ", "
        End If
        checkTexts += MagazineCheckBox.Text
      End If
      If FriendCheckBox.Checked Then
        If checkTexts <> "" Then
          checkTexts += ", "
        End If
        checkTexts += FriendCheckBox.Text
      End If
      If WebSearchCheckBox.Checked Then
        If checkTexts <> "" Then
          checkTexts += ", "
        End If
        checkTexts += WebSearchCheckBox.Text
      End If
      If OtherCheckBox.Checked Then
        If checkTexts <> "" Then
          checkTexts += ", "
        End If
        checkTexts += OtherCheckBox.Text
        checkTexts += String.Format( _
          "（{0}）" _
          , OtherDetailTextBox.Text)
      End If
      ResultLabel.Text += String.Format( _
        "サイトをどこで知ったか：{0}" _
        , checkTexts)
      ResultLabel.Text += "<br />"
      ' サイトの評価
      Dim ratingText As String = ""
      If VeryGoodRadioButton.Checked Then
        ratingText = VeryGoodRadioButton.Text
      End If
      If GoodRadioButton.Checked Then
        ratingText = GoodRadioButton.Text
      End If
      If NormalRadioButton.Checked Then
        ratingText = NormalRadioButton.Text
      End If
      If BadRadioButton.Checked Then
        ratingText = BadRadioButton.Text
      End If
      If VeryBadRadioButton.Checked Then
        ratingText = VeryBadRadioButton.Text
      End If
      ResultLabel.Text += String.Format( _
        "サイトの評価：{0}" _
        , ratingText)
      ResultLabel.Text += "<br />"
      ' 評価の理由
      ResultLabel.Text += String.Format( _
        "評価の理由：{0}" _
        , ReasonTextBox.Text)
      ResultLabel.Text += "<br />"
      ' 意見、要望など
      ResultLabel.Text += String.Format( _
        "意見、要望など：{0}" _
        , FreeTextBox.Text _
          .Replace(Environment.NewLine, "<br />"))
    End If
  End Sub

End Class